# Class AbstractTest

java.lang.Object
com.codename1.testing.AbstractTest

All Implemented Interfaces:
  `UnitTest`

public abstract class AbstractTest extends Object implements UnitTest
A unit test class that simplifies the process of writing test cases for Codename One.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractTest()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `assertArrayEqual(byte[] expected, byte[] actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(byte[] expected, byte[] actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(double[] expected, double[] actual, double maxRelativeError)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(double[] expected, double[] actual, double maxRelativeError, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(float[] expected, float[] actual, double maxRelativeError)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(float[] expected, float[] actual, double maxRelativeError, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(int[] expected, int[] actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(int[] expected, int[] actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(long[] expected, long[] actual, long maxRelativeError)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(long[] expected, long[] actual, long maxRelativeError, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(short[] expected, short[] actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(short[] expected, short[] actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(Object[] expected, Object[] actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertArrayEqual(Object[] expected, Object[] actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertBool(boolean b)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertBool(boolean b, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(byte expected, byte actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(byte expected, byte actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(double expected, double actual, double maxRelativeError)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(double expected, double actual, double maxRelativeError, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(float expected, float actual, double maxRelativeError)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(float expected, float actual, double maxRelativeError, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(int expected, int actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(int expected, int actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(long expected, long actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(long expected, long actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(short expected, short actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(short expected, short actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(Object expected, Object actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertEqual(Object expected, Object actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertException(RuntimeException exception, Runnable expression)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertException(RuntimeException exception, Runnable expression, String message)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertFalse(boolean value)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertFalse(boolean value, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertLabel(int[] path, String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertLabel(String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertLabel(String name, String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNoException(Runnable expression)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNoException(Runnable expression, String message)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(byte expected, byte actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(byte expected, byte actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(double expected, double actual, double minRelativeError)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(double expected, double actual, double minRelativeError, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(float expected, float actual, double minRelativeError)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(float expected, float actual, double minRelativeError, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(int expected, int actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(int expected, int actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(long expected, long actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(long expected, long actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(short expected, short actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(short expected, short actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(Object expected, Object actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotEqual(Object expected, Object actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotNull(Object object)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotNull(Object object, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotSame(Object expected, Object actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNotSame(Object expected, Object actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNull(Object object)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertNull(Object object, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertRange(double expected, double actual, double maxAbsoluteError)`

  ###### Since

  `void`
  `assertRange(double expected, double actual, double maxAbsoluteError, String errorMessage)`

  ###### Since

  `void`
  `assertSame(Object expected, Object actual)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertSame(Object expected, Object actual, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertTextArea(int[] path, String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertTextArea(String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertTextArea(String name, String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertTitle(String title)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertTrue(boolean value)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `assertTrue(boolean value, String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `cleanup()`
  Cleanup after a test case executed
  `void`
  `clickButtonByLabel(String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `clickButtonByName(String name)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `clickButtonByPath(int[] path)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `clickMenuItem(String name)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `ensureVisible(int[] c)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `ensureVisible(Component c)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `ensureVisible(String c)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `executeToolbarCommandAtOffset(int offset)`
  Executes a command from the offset returned by `#getToolbarCommands()`
  `void`
  `fail()`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `fail(String errorMessage)`
  This method just invokes the test utils method, it is here for convenience
  `Component`
  `findByName(String componentName)`
  This method just invokes the test utils method, it is here for convenience
  `Label`
  `findLabelText(String text)`
  This method just invokes the test utils method, it is here for convenience
  `TextArea`
  `findTextAreaText(String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `gameKeyPress(int gameKey)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `gameKeyRelease(int gameKey)`
  This method just invokes the test utils method, it is here for convenience
  `Component`
  `getComponentByPath(int[] path)`
  This method just invokes the test utils method, it is here for convenience
  `int`
  `getTimeoutMillis()`
  Defaults to two minutes.
  `Command[]`
  `getToolbarCommands()`
  Returns all the command objects from the toolbar in the order of left, right, overflow & sidemenu
  `void`
  `goBack()`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `keyPress(int keyCode)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `keyRelease(int keyCode)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `log(String t)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `log(Throwable t)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `pointerDrag(float x, float y, int[] path)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `pointerDrag(float x, float y, String componentName)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `pointerPress(float x, float y, int[] path)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `pointerPress(float x, float y, String componentName)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `pointerRelease(float x, float y, int[] path)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `pointerRelease(float x, float y, String componentName)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `prepare()`
  Prepares the unit test for execution
  `boolean`
  `screenshotTest(String screenshotName)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `selectInList(int[] path, int offset)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `selectInList(String listName, int offset)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `setText(int[] path, String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `setText(String name, String text)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `setVerboseMode(boolean v)`
  This method just invokes the test utils method, it is here for convenience
  `boolean`
  `shouldExecuteOnEDT()`
  Returns false, default tests run in their own thread.
  `void`
  `showSidemenu()`
  Shows the sidemenu UI
  `void`
  `waitFor(int millis)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `waitForFormName(String name)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `waitForFormTitle(String title)`
  This method just invokes the test utils method, it is here for convenience
  `void`
  `waitForUnnamedForm()`
  Waits for a form change and if no form change occurred after a given timeout then fail the test

  ### Methods inherited from class Object

  `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `final Class`
  `getClass()`
  Returns the runtime class of an object.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes current thread to wait until another thread invokes the method or the method for this object.
  `final void`
  `wait(long timeout)`
  Causes current thread to wait until either another thread invokes the method or the method for this object, or a specified amount of time has elapsed.
  `final void`
  `wait(long timeout, int nanos)`
  Causes current thread to wait until another thread invokes the method or the method for this object, or some other thread interrupts the current thread, or a certain amount of real time has elapsed.

  ### Methods inherited from interface UnitTest

  `runTest`
  Modifier and Type
  Method
  Description
  `boolean`
  `runTest()`
  Runs a unit test, if it returns true it passed.

- ## Constructor Details

  - ### AbstractTest

    public AbstractTest()

- ## Method Details

  - ### prepare

    public void prepare()
    Prepares the unit test for execution
    Specified by:
      `prepare` in interface `UnitTest`

  - ### cleanup

    public void cleanup()
    Cleanup after a test case executed
    Specified by:
      `cleanup` in interface `UnitTest`

  - ### getTimeoutMillis

    public int getTimeoutMillis()

    Defaults to two minutes.

    Returns the time in milliseconds after which the test should be automatically failed.

    ###### Returns

    time in milliseconds

    Specified by:
      `getTimeoutMillis` in interface `UnitTest`

  - ### shouldExecuteOnEDT

    public boolean shouldExecuteOnEDT()

    Returns false, default tests run in their own thread.

    Returns true to indicate that the test expects to be executed on the EDT

    ###### Returns

    whether the test should execute on the EDT or the testing thread

    Specified by:
      `shouldExecuteOnEDT` in interface `UnitTest`

  - ### assertBool

    public void assertBool(boolean b)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertBool

    public void assertBool(boolean b, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### fail

    public void fail()

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### fail

    public void fail(String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertTrue

    public void assertTrue(boolean value)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertTrue

    public void assertTrue(boolean value, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertFalse

    public void assertFalse(boolean value)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertFalse

    public void assertFalse(boolean value, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNull

    public void assertNull(Object object)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNull

    public void assertNull(Object object, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotNull

    public void assertNotNull(Object object)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotNull

    public void assertNotNull(Object object, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertSame

    public void assertSame(Object expected, Object actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertSame

    public void assertSame(Object expected, Object actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotSame

    public void assertNotSame(Object expected, Object actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotSame

    public void assertNotSame(Object expected, Object actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(byte expected, byte actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(byte expected, byte actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(short expected, short actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(short expected, short actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(int expected, int actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(int expected, int actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(long expected, long actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(long expected, long actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(float expected, float actual, double maxRelativeError)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(float expected, float actual, double maxRelativeError, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(double expected, double actual, double maxRelativeError)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertRange

    public void assertRange(double expected, double actual, double maxAbsoluteError)

    ###### Since

    8.0

    ###### See also

    - TestUtils#assertRange(double, double, double)

  - ### assertRange

    public void assertRange(double expected, double actual, double maxAbsoluteError, String errorMessage)

    ###### Since

    8.0

    ###### See also

    - TestUtils#assertRange(double, double, double, String)

  - ### assertEqual

    public void assertEqual(double expected, double actual, double maxRelativeError, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(Object expected, Object actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertEqual

    public void assertEqual(Object expected, Object actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(byte expected, byte actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(byte expected, byte actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(short expected, short actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(short expected, short actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(int expected, int actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(int expected, int actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(long expected, long actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(long expected, long actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(float expected, float actual, double minRelativeError)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(float expected, float actual, double minRelativeError, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(double expected, double actual, double minRelativeError)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(double expected, double actual, double minRelativeError, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(Object expected, Object actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNotEqual

    public void assertNotEqual(Object expected, Object actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(byte[] expected, byte[] actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(byte[] expected, byte[] actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(short[] expected, short[] actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(short[] expected, short[] actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(int[] expected, int[] actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(int[] expected, int[] actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(long[] expected, long[] actual, long maxRelativeError)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(long[] expected, long[] actual, long maxRelativeError, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(float[] expected, float[] actual, double maxRelativeError)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(float[] expected, float[] actual, double maxRelativeError, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(double[] expected, double[] actual, double maxRelativeError)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(double[] expected, double[] actual, double maxRelativeError, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(Object[] expected, Object[] actual)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertArrayEqual

    public void assertArrayEqual(Object[] expected, Object[] actual, String errorMessage)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertException

    public void assertException(RuntimeException exception, Runnable expression)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertException

    public void assertException(RuntimeException exception, Runnable expression, String message)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNoException

    public void assertNoException(Runnable expression)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertNoException

    public void assertNoException(Runnable expression, String message)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### waitFor

    public void waitFor(int millis)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### findByName

    public Component findByName(String componentName)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### findLabelText

    public Label findLabelText(String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### clickButtonByLabel

    public void clickButtonByLabel(String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### clickButtonByName

    public void clickButtonByName(String name)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### clickButtonByPath

    public void clickButtonByPath(int[] path)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### goBack

    public void goBack()

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### clickMenuItem

    public void clickMenuItem(String name)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### ensureVisible

    public void ensureVisible(Component c)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### ensureVisible

    public void ensureVisible(int[] c)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### ensureVisible

    public void ensureVisible(String c)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### waitForFormTitle

    public void waitForFormTitle(String title)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### waitForUnnamedForm

    public void waitForUnnamedForm()
    Waits for a form change and if no form change occurred after a given timeout then fail the test

  - ### waitForFormName

    public void waitForFormName(String name)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### log

    public void log(String t)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### log

    public void log(Throwable t)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### screenshotTest

    public boolean screenshotTest(String screenshotName)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### keyPress

    public void keyPress(int keyCode)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### keyRelease

    public void keyRelease(int keyCode)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### gameKeyPress

    public void gameKeyPress(int gameKey)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### gameKeyRelease

    public void gameKeyRelease(int gameKey)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### pointerPress

    public void pointerPress(float x, float y, String componentName)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### pointerRelease

    public void pointerRelease(float x, float y, String componentName)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### pointerDrag

    public void pointerDrag(float x, float y, String componentName)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### pointerPress

    public void pointerPress(float x, float y, int[] path)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### pointerRelease

    public void pointerRelease(float x, float y, int[] path)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### pointerDrag

    public void pointerDrag(float x, float y, int[] path)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### getComponentByPath

    public Component getComponentByPath(int[] path)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### setText

    public void setText(String name, String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### setText

    public void setText(int[] path, String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertTitle

    public void assertTitle(String title)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertLabel

    public void assertLabel(String name, String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertLabel

    public void assertLabel(String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertLabel

    public void assertLabel(int[] path, String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertTextArea

    public void assertTextArea(String name, String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertTextArea

    public void assertTextArea(int[] path, String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### assertTextArea

    public void assertTextArea(String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### findTextAreaText

    public TextArea findTextAreaText(String text)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### setVerboseMode

    public void setVerboseMode(boolean v)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### selectInList

    public void selectInList(String listName, int offset)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### selectInList

    public void selectInList(int[] path, int offset)

    This method just invokes the test utils method, it is here for convenience

    ###### See also

    - TestUtils

  - ### getToolbarCommands

    public Command[] getToolbarCommands()

    Returns all the command objects from the toolbar in the order of left, right, overflow & sidemenu

    ###### Returns

    the set of commands

  - ### executeToolbarCommandAtOffset

    public void executeToolbarCommandAtOffset(int offset)

    Executes a command from the offset returned by `#getToolbarCommands()`

    ###### Parameters

    - `offset`: the offset of the command we want to execute

  - ### showSidemenu

    public void showSidemenu()
    Shows the sidemenu UI